stages:
  - Tag
  - QA
  - BuildSecondPhase
  - Release

.olo-syncer_job_variables:
  variables:
    BACKEND_PATH: "backend/olo-syncer"
    ADD_JOB_ON_CHANGES_OF_4: "backend/p5-bttw-tools/**/*"
    ADD_JOB_ON_CHANGES_OF_5: "backend/p5-service-http-library/**/*"
    LOCAL_BUILDKIT_ARCHS: "linux/amd64"
    IMAGE: "${CI_REGISTRY_IMAGE}/backend/p5-service-http-library:${VERSION}"

olo-syncer:Tag latest container when there are no changes:
  extends: 
    - .olo-syncer_job_variables
    - .tag_latest_backend_container_template
  # only is used to add this job only when the app or ci template is NOT changed
  # This is not supported yet by rules
  only:
    variables:
      - $CI_COMMIT_TAG =~ /^release\//
      - $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development)$/
  except:
    refs:
      - schedule
      - web
    changes:
      - "backend/olo-syncer/**/*"
      - "backend/p5-bttw-tools/**/*"
      - "backend/p5-service-http-library/**/*"
      - "template.gitlab-ci.yml"

.build_olo_syncer_container:
  extends:
    - .olo-syncer_job_variables
    - .build_and_push_container_image_template
  stage: BuildSecondPhase

olo-syncer:Build container image (x86_64):
  extends: .build_olo_syncer_container
  tags: [ "xxllnc-shared", "arch:x86_64" ]
  variables:
    BUILD_ARCH: "amd64"

olo-syncer:Build container image (arm64):
  extends: .build_olo_syncer_container
  tags: [ "xxllnc-shared", "arch:arm64" ]
  variables:
    BUILD_ARCH: "arm64"

olo-syncer:Make multiarch manifest:
  extends:
    - .olo-syncer_job_variables
    - .make_multiarch_manifest_template
  stage: BuildSecondPhase
  variables:
    BUILD_ARCHS: "amd64 arm64"
  needs:
    - "set-version-number-and-tag-commit"
    - "olo-syncer:Build container image (x86_64)"
    - "olo-syncer:Build container image (arm64)"

olo-syncer:Check licenses:
  stage: BuildSecondPhase
  extends:
    - .olo-syncer_job_variables
    - .perl_license_check_template
    - .build_verify_rules
  variables:
    CONTAINER_IMAGE: "${CI_REGISTRY_IMAGE}/${BACKEND_PATH}:${VERSION}"
  needs:
    - "set-version-number-and-tag-commit"
    - "olo-syncer:Make multiarch manifest"

#
# Release targets
#
olo-syncer:Tag xcp release container:
  extends:
    - .olo-syncer_job_variables
    - .release_on_xcp

